| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLESProgramManager Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program object that represents the active vertex and fragment shader objects during a rendering state. More...

`#include <OgreGLSLESProgramManager.h>`

Inheritance diagram for Ogre::GLSLESProgramManager:
[legend]

## Public Member Functions
| GLSLESProgramManager (void)
| ~GLSLESProgramManager (void)
void | destroyAllByShader (GLSLShaderCommon *shader)
| Destroy all programs which referencing this shader. More...
bool | destroyLinkProgram (GLSLESProgramCommon *linkProgram)
| Destroy and remove the linker program from the local cache. More...
void | extractUniformsFromGLSL (const String &src, GpuNamedConstants &constantDefs, const String &filename)
| Populate a list of uniforms based on GLSL source and store them in GpuNamedConstants. More...
GLSLESProgramCommon * | getActiveProgram (void)
| Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked. More...
GLSLESProgramCommon * | getByProgram (GLSLESProgram *gpuProgram)
| Get the linker program by a gpu program. More...
void | optimiseShaderSource (GLSLESGpuProgram *gpuProgram)
void | setActiveFragmentShader (GLSLESProgram *fragmentGpuProgram)
| Set the active shader for the next rendering state. More...
void | setActiveVertexShader (GLSLESProgram *vertexGpuProgram)
| Set the active shader for the next rendering state. More...

## Static Public Member Functions
static void | extractUniforms (GLuint programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &list, GLUniformBufferList &sharedList)
| Populate a list of uniforms based on a program object. More...
static GLSLESProgramManager & | getSingleton (void)
static GLSLESProgramManager * | getSingletonPtr (void)

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program object that represents the active vertex and fragment shader objects during a rendering state.

GLSL Vertex and fragment shader objects are compiled separately and then attached to a program object and then the program object is linked. Since Ogre can only handle one vertex program and one fragment program being active in a pass, the GLSL ES Link Program Manager does the same. The GLSL ES Link program manager acts as a state machine and activates a program object based on the active vertex and fragment program. Previously created program objects are stored along with a unique key in a hash_map for quick retrieval the next time the program object is required.

## Constructor & Destructor Documentation

## ◆ GLSLESProgramManager()

Ogre::GLSLESProgramManager::GLSLESProgramManager | ( | void |  | ) |

## ◆ ~GLSLESProgramManager()

Ogre::GLSLESProgramManager::~GLSLESProgramManager | ( | void |  | ) |

## Member Function Documentation

## ◆ setActiveFragmentShader()

void Ogre::GLSLESProgramManager::setActiveFragmentShader | ( | GLSLESProgram * | fragmentGpuProgram | ) |

Set the active shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLESGpuProgram::bindProgram and unbindProgram methods

## ◆ setActiveVertexShader()

void Ogre::GLSLESProgramManager::setActiveVertexShader | ( | GLSLESProgram * | vertexGpuProgram | ) |

Set the active shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLESGpuProgram::bindProgram and unbindProgram methods

## ◆ getActiveProgram()

GLSLESProgramCommon* Ogre::GLSLESProgramManager::getActiveProgram | ( | void |  | ) |

Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked.

## ◆ getByProgram()

GLSLESProgramCommon* Ogre::GLSLESProgramManager::getByProgram | ( | GLSLESProgram * | gpuProgram | ) |

Get the linker program by a gpu program.

## ◆ destroyLinkProgram()

bool Ogre::GLSLESProgramManager::destroyLinkProgram | ( | GLSLESProgramCommon * | linkProgram | ) |

Destroy and remove the linker program from the local cache.

## ◆ optimiseShaderSource()

void Ogre::GLSLESProgramManager::optimiseShaderSource | ( | GLSLESGpuProgram * | gpuProgram | ) |

## ◆ extractUniforms()

static void Ogre::GLSLESProgramManager::extractUniforms | ( | GLuint | programObject,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReferenceList & | list,
|  | GLUniformBufferList & | sharedList
| ) |  |
| static

Populate a list of uniforms based on a program object.

Parameters

  programObject | Handle to the program object to query
  vertexConstantDefs | Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program.
  fragmentConstantDefs | Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program.
  list | The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).

## ◆ getSingleton()

static GLSLESProgramManager& Ogre::GLSLESProgramManager::getSingleton | ( | void |  | ) |
| static

## ◆ getSingletonPtr()

static GLSLESProgramManager* Ogre::GLSLESProgramManager::getSingletonPtr | ( | void |  | ) |
| static

## ◆ extractUniformsFromGLSL()

void Ogre::GLSLProgramManagerCommon::extractUniformsFromGLSL | ( | const String & | src,
|  | GpuNamedConstants & | constantDefs,
|  | const String & | filename
| ) |  |
| inherited

Populate a list of uniforms based on GLSL source and store them in GpuNamedConstants.

Parameters

  src | Reference to the source code.
  constantDefs | The defs to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).
  filename | The file name this came from, for logging errors.

## ◆ destroyAllByShader()

void Ogre::GLSLProgramManagerCommon::destroyAllByShader | ( | GLSLShaderCommon * | shader | ) |
| inherited

Destroy all programs which referencing this shader.

The documentation for this class was generated from the following file:

- OgreGLSLESProgramManager.h